<?php
// Initialize error reporting
error_reporting(0);
// ini_set('display_errors', 1);

// Include JWT library
require_once '../php-jwt-6.0.0/src/JWT.php';

// Include configuration and utility files
require_once '../includes/config.inc.php';
require_once '../utils/util.php';
require_once '../phpqrcode/qrlib.php';
// Include other necessary files
require_once 'classes/plusMailer.php';
require_once 'classes/iplus.php';
require_once 'classes/upload-class.php';
require_once 'classes/class.api-push-notifications.php';
require_once 'classes/class.entity.php';
require_once 'classes/class.subscription_plan.php';
require_once 'classes/class.trail_duration.php';
require_once 'classes/class.member_subscription.php';
require_once('classes/class.languages.php');
require_once 'classes/class.hs256.php';
require_once 'classes/class.users.php';
require_once('classes/class.settings.php');
require_once 'classes/class.levels.php';
require_once 'classes/class.pages.php';

// Set timezone
date_default_timezone_set('Africa/Cairo');

// Function to get Apache request headers
if( !function_exists('apache_request_headers') ) {
    ///
    function apache_request_headers() {
      $arh = array();
      $rx_http = '/\AHTTP_/';
      foreach($_SERVER as $key => $val) {
        if( preg_match($rx_http, $key) ) {
          $arh_key = preg_replace($rx_http, '', $key);
          $rx_matches = array();
          // do some nasty string manipulations to restore the original letter case
          // this should work in most cases
          $rx_matches = explode('_', $arh_key);
          if( count($rx_matches) > 0 and strlen($arh_key) > 2 ) {
            foreach($rx_matches as $ak_key => $ak_val) $rx_matches[$ak_key] = ucfirst($ak_val);
            $arh_key = implode('-', $rx_matches);
          }
          $arh[$arh_key] = $val;
        }
      }
      return( $arh );
    }
    ///
    }
    
$http_response_code_status = 200;

if ($Config['mode'] == 'live' && $commonObj->getSettingByName('api_secrit_key_on') == '1') {
    $apiSeritKey_correct = password_verify('rAm', $apache_request_headers['AUTHORIZATION']);

    if (!$apiSeritKey_correct) {
        $http_response_code_status = 401;
        goto out;
    }
    //cheak if there api Secrit key is not Duplicate
    $is_exist = $userObj->checkSecritKeyIsExist($apache_request_headers['AUTHORIZATION']);
    // echo $is_exist;
    if ($is_exist) {
        $http_response_code_status = 401;
        goto out;
    }
    //insert api Secrit key in table
    $userObj->insertSecritKey($apache_request_headers['AUTHORIZATION']);
}



// Get Apache request headers
$apache_request_headers = apache_request_headers();

// print_r ($apache_request_headers);
// die();
// Set CORS headers
header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: GET,POST,PUT,DELETE,OPTIONS');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');

$token  = apache_request_headers()["AUTHORIZATION"];
$verify = $hs256Obj->verifyJWT('sha256', $token);


out:

// echo "TESTSTSF";die();
if ($http_response_code_status != 200) {
    http_response_code($http_response_code_status);
    echo str_replace("\'", "'", json_encode($ret));
    $userObj->inserInApiTable($http_response_code_status, json_encode($_SERVER), json_encode($apache_request_headers), json_encode($Req, JSON_UNESCAPED_UNICODE), json_encode($_GET, JSON_UNESCAPED_UNICODE), json_encode($ret, JSON_UNESCAPED_UNICODE));
    exit();
}                                                                                     

// echo $verify;die();

?>
