<?php

/* * *************************************************************************
 *
 *   PROJECT: Tahalya app
 *   powerd by IT PLUS Team
 *   Copyright 2020 IT Plus Inc
 *   http://it-plus.co/ *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */

header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: GET,POST,PUT,DELETE,OPTIONS');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');

require_once 'init.php';

// Start Functionality
$postdata = file_get_contents("php://input");
if ($_GET['action'] == 'getAllPages') {
    // Initialize default values or retrieve from $_GET
     $start         = $_GET['start'] ? $_GET['start'] : 0;
        $aItemsPerPage = $_GET['aItemsPerPage'] ? $_GET['aItemsPerPage'] : 15;

        $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
        $type = $_GET['type'] ? $_GET['type'] : 'DESC';

        $searchTitle = $_GET['searchTitle'] ? $_GET['searchTitle'] : '';

    // Get total count of pages
    $pagesCount = $pagesObj->getPagesCount($searchTitle);

    // Fetch pages data based on parameters
    $pagesData = $pagesObj->getAllPages($start, $aItemsPerPage, $sort, $type, $searchTitle);

    // Prepare response data
    $responseData = array(
        "pages_count" => $pagesCount,
        "pages_data" => $pagesData
    );

    // Output JSON response
    header('Content-Type: application/json');
    echo json_encode($responseData);
}

if ($_GET['action'] == 'getSearchPagesCount') {

    

        $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
        $type = $_GET['type'] ? $_GET['type'] : 'DESC';

        $searchTitle = $_GET['searchTitle'] ? $_GET['searchTitle'] : '';

        $pagesSearchData = $pagesObj->getSearchPagesCount($sort, $type, $searchTitle);

        $Data = $pagesSearchData ? $pagesSearchData : '';
        echo json_encode($Data);
 

}

// if ($_GET['action'] == 'getPagesCount') {

//     // $token  = apache_request_headers()["Authorization"];
//     // $verify = $hs256Obj->verifyJWT('sha256', $token);

//     // if (isset($token) && isset($verify) && $verify) {

//         $pagesData = $pagesObj->getPagesCount();
//         $Data      = $pagesData ? $pagesData : '';
//         echo json_encode($Data);
//     // } else {
//     //     echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
//     // }

// }

if ($_GET['action'] == 'addEditPage') {
// echo"TEST";die();

        $temp = array();
        $allow_ext = array("jpg", "gif", "png", "jpeg", "bmp", "webp");
        $maxsize = 1024 * 2; //kb
        // $uploadFolder = 'wethaq/api/uploads/banks';
        $uploadFolder = $Config['uploads_path'] . 'pages';
        // echo $uploadFolder;die();

        $thumbsConfig = array(
            array(
                'name' => 'medium',
                'width' => '240',
                'hight' => '250'
            ),
            array(
                'name' => 'small',
                'width' => '80',
                'hight' => '80'
            ),
        );


        $upload = new Upload($allow_ext, $thumbsConfig, $maxsize, $uploadFolder, false);

        if (isset($_FILES['file']['name']) AND $_FILES['file']['name'] != '') {

            //get file name
            $file['name'] = addslashes($_FILES["file"]["name"]);
            // get file type
            $file['type'] = $_FILES["file"]['type'];
            // get filesize in KB
            $file['size'] = $_FILES["file"]['size'] / 1024;
            // get file tmp path
            $file['tmp'] = $_FILES["file"]['tmp_name'];
            //get file ext [to get max uploades size]
            $file['ext'] = $upload->GetExt($_FILES["file"]["name"]);
            //check if guest have selected file or not
            if ($file['name'] != '') {
                // Start Uploading File
                
                $upfile = $upload->Upload_File($file, $maxsize);
                    // echo $upfile;die();
                //if uploagetStageByParentIDding successfully
                if ($upfile) {
                    $temp['file'] = $upfile['newname'];
                    
                } else {
                    $error = true;
                    $showError[] = $upload->showErrors();
                    $top_msg['error'][] = $showError[0][0];
                }
            }
        }
        else
        {
            $temp = null;
        }
        // print_r($_FILES);die();
        

        $pageData = $pagesObj->addEditPage($_REQUEST,$temp['file']);
        $Data     = $pageData ? $pageData : '';
        echo json_encode($Data);


}




if ($_GET['action'] == 'getOnePage') {
    $id = $_GET['id'];
    $pageData = $pagesObj->getOnePage($id);

    // Ensure the response is an array
    if (is_array($pageData)) {
        // Output JSON response
        header('Content-Type: application/json');
        echo json_encode($pageData);
    } else {
        // Handle error if pageData is not an array
        header('Content-Type: application/json');
        echo json_encode(array('error' => 'Invalid data format.'));
    }
}

    

    if ($_GET['action'] == 'deletePage') {

       $Req = json_decode($postdata, true);

            $pageData = $pagesObj->deletePage($Req['id']);
            $Data     = $pageData ? $pageData : '';
            echo json_encode($Data);
    

    

}
