<?php

/* * *************************************************************************
 *
 *   PROJECT: BigWish App
 *   powerd by IT PLUS Team
 *   Copyright 2020 IT Plus Inc
 *   http://it-plus.co/ *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */

header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: GET,POST,PUT,DELETE,OPTIONS');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');


require_once 'init.php';

// Start Functionality
$postdata = file_get_contents("php://input");

$Req = json_decode($postdata,TRUE);
        // print_r( $Req);
        // die();
// if (isset($token) && isset($verify) && $verify) {   
if($_GET['action'] == 'login') {
    $email = $Req['email'];
    $password = $Req['password'];
    $dial_code = isset($Req['dial_code']) ? $Req['dial_code'] : null;
    $country_symbol = isset($Req['country_symbol']) ? $Req['country_symbol'] : null;

    $userData = $userAdmObj->login($email, $password, $dial_code, $country_symbol);

    if ($userData) {
        $usersSubscription = $userAdmObj->getusersSubscription($userData['id']);
        $Data = array(
            "User_data" => $userData,
            "User_Subscription" => $usersSubscription
        );
    } else {
        $Data = array(
            'errors' => 'Please check your email and Password',
        );
    }

    
}

    if ($_GET['action'] == 'getUsersLevels') {  

 

        $leveltype=$_GET['level_type'] ?$_GET['level_type'] :"admin";
        $provider_id=$_GET['provider_id'] ?$_GET['provider_id'] :"";
        $usersLevelsData = $userAdmObj->getUsersLevels($leveltype,$provider_id);
        $Data = $usersLevelsData?$usersLevelsData:''; 
       
   

}
if($_GET['action'] == 'getClubMemberCount') {
    
    if ($_SERVER['REQUEST_METHOD'] === 'GET') {
        
        // $lang_code = $_GET['lang_code'] ? $_GET['lang_code'] : "ar";
        $start         = $_GET['start'] ? $_GET['start'] : 0;
        $aItemsPerPage = $_GET['aItemsPerPage'] ? $_GET['aItemsPerPage'] : 5;

        $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
        $type = $_GET['type'] ? $_GET['type'] : 'DESC';

        $searchName = $_GET['searchName'] ? $_GET['searchName'] : '';
        
        $clubMemberCount = $userAdmObj->getClubMemberCount();
        $clubMemberEnteringCount = $userAdmObj->getQrcodeHistorycount();
        
         $Data = array(
            "clubMembers_count" => $clubMemberCount,
            "clubMembersEntering_Count" => $clubMemberEnteringCount
        );
    }
}  

if($_GET['action'] == 'addQrcodeHistoryInfo') {
        $user_id = $Req['user_id'];
    	$entity_id = $Req['entity_id'];
    	$added_by = $Req['added_by'];
        $userData = $userAdmObj->addQrcodeHistoryInfo($user_id, $entity_id,$added_by);
        // print_r($userData);
        // die();
        $Data     = $userData ? $userData : '';

      
    
        
    }
if($_GET['action'] == 'getClubMemberCount') {
    
    if ($_SERVER['REQUEST_METHOD'] === 'GET') {
        
        // $lang_code = $_GET['lang_code'] ? $_GET['lang_code'] : "ar";
        $start         = $_GET['start'] ? $_GET['start'] : 0;
        $aItemsPerPage = $_GET['aItemsPerPage'] ? $_GET['aItemsPerPage'] : 5;

        $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
        $type = $_GET['type'] ? $_GET['type'] : 'DESC';

        $searchName = $_GET['searchName'] ? $_GET['searchName'] : '';
        
        $clubMemberCount = $userAdmObj->getClubMemberCount();
        $clubMemberEnteringCount = $userAdmObj->getQrcodeHistorycount();
        
         $Data = array(
            "clubMembers_count" => $clubMemberCount,
            "clubMembersEntering_Count" => $clubMemberEnteringCount
        );
    }
}  
    
if($_GET['action'] == 'getQrcodeHistoryInfo') {
    
    // echo $QRCodeData;
    // die();
     $entityData = $_REQUEST['entity_id'];
     $scannedQRCodeData = $_REQUEST['user_id'];
     $searchName = $_GET['searchName'] ? $_GET['searchName'] : '';
     $searchUserMemberShipID = $_GET['membershipID'] ? $_GET['membershipID'] : '';
     $searchDateFrom = $_GET['searchDateFrom'] ? $_GET['searchDateFrom'] : '';
     $searchDateTo = $_GET['searchDateTo'] ? $_GET['searchDateTo'] :  $dateTime ;
    //  print_r($searchUserMemberShipID);
    //  die();
    // Call the function to get user data from the scanned QR code
    $Data = $userAdmObj -> getQrcodeHistoryInfo($searchName, $searchUserMemberShipID, $searchDateFrom, $searchDateTo, $scannedQRCodeData, $entityData);

      
    
        
    }

if($_GET['action'] == 'getAllUsers') {
    
    if ($_SERVER['REQUEST_METHOD'] === 'GET') {
        
        // $lang_code = $_GET['lang_code'] ? $_GET['lang_code'] : "ar";
        $start         = $_GET['start'] ? $_GET['start'] : 0;
        $aItemsPerPage = $_GET['aItemsPerPage'] ? $_GET['aItemsPerPage'] : 5;

        $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
        $type = $_GET['type'] ? $_GET['type'] : 'DESC';

        $searchName = $_GET['searchName'] ? $_GET['searchName'] : '';
        $searchUserPhone = $_GET['searchUserPhone'] ? $_GET['searchUserPhone'] : '';
        $searchUserMemberShipID = $_GET['membershipID'] ? $_GET['membershipID'] : '';
        $searchStartDate = $_GET['searchStartDate'] ? $_GET['searchStartDate'] : '';
        $searchEndDate = $_GET['searchEndDate'] ? $_GET['searchEndDate'] : '';
        $searchUserStatus = $_GET['searchUserStatus'] !='' ? $_GET['searchUserStatus'] : '';
        $searchUserType = $_GET['searchUserType'] ? $_GET['searchUserType'] : '';
        
        $usersCount = $userAdmObj->getUsersCount($searchUserMemberShipID, $searchName, $searchUserPhone, $searchStartDate, $searchEndDate, $searchUserStatus, $searchUserType);
        
        
        

        $users_data = $userAdmObj->getSomeUsers($userType, $aStart, $aLimit, $sort, $type,$searchUserMemberShipID, $searchName,$searchUserPhone,$searchStartDate,$searchEndDate,$searchUserStatus,$searchUserType);
       
        
         $Data = array(
            "Users_count" => $usersCount,
            "Users_data" => $users_data
        );
    }
}  
if ($_GET['action'] == 'getOneUser') {

     

            $userType = $_GET['userType'] ? $_GET['userType'] : '';
            $Req = $_GET['id'] ? $_GET['id'] : '';
            // print_r($Req);
            // die();
            $oneUsersData = $userAdmObj->getOneUser($userType, $Req);
            $Data = $oneUsersData?$oneUsersData:'';
           

    }

if ($_GET['action'] == 'addEditUser') {
//   print_r($_REQUEST);die();
    $operation = $_REQUEST['operation'];
    $user_id = '';

    $temp = array();

    $allow_ext = array("jpg", "gif", "png", "jpeg", "bmp", "webp");
    $maxsize = 1024 * 20; //kb
    // $uploadFolder = 'wethaq/api/uploads/banks';
    $uploadFolder = $Config['uploads_path'] . 'users';

    $thumbsConfig = array(
        array(
            'name' => 'medium',
            'width' => '240',
            'hight' => '250'
        ),
        array(
            'name' => 'small',
            'width' => '80',
            'hight' => '80'
        ),
    );
    
    $upload = new Upload($allow_ext, $thumbsConfig, $maxsize, $uploadFolder, false);
    // print_r($_FILES);die();
    foreach($_FILES as $key => $img){
        
        if (isset($_FILES[$key]['name']) AND $_FILES[$key]['name'] != '') {
        
            //get file name
            $file['name'] = addslashes($_FILES[$key]["name"]);
            // get file type
            $file['type'] = $_FILES[$key]['type'];
            // get filesize in KB
            $file['size'] = $_FILES[$key]['size'] / 1024;
            // get file tmp path
            $file['tmp'] = $_FILES[$key]['tmp_name'];
            //get file ext [to get max uploades size]
            $file['ext'] = $upload->GetExt($_FILES[$key]["name"]);
            //check if guest have selected file or not
            if ($file['name'] != '') {
                // Start Uploading File
                $upfile = $upload->Upload_File($file, $maxsize);
                //if uploagetCategoryByParentIDding successfully
                // echo $upfile;die();
                if ($upfile) {
                    $temp[$key] = $upfile['newname'];
                    // print_r ($temp[$key]);die();
                } else {
                    $error = true;
                    $showError[] = $upload->showErrors();
                    $top_msg['error'][] = $showError[0][0];
                     echo $showError[0][0];die();
                }
            }
        }
        else
        {
            $temp = null;
        }
       
    }

    $user_id = $_REQUEST['id'];
    

    
    if ($user_id){
        $userDetailsData = $userAdmObj->getAllDetailsUserData($user_id);
    }
   
    $data = $userAdmObj->addEditUser($_REQUEST, $temp, $user_id);
    // print_r($data );die();
     $header = [
            "alg"   => "HS256",
            "typ"   => "JWT"
        ];
        // JWT Payload data
        $payload = [
            "user_id"   => $data
        ];
        $token = $hs256Obj->generateJWT('sha256', $header, $payload);
        $returnedData = ['token'=> $token, 'userData'=> $data];
        $userAdmObj->insertAuthCode($data,$token );
        
        
        if(($_REQUEST['type'] =='club_member')||( $_REQUEST['type'] =='captain') ||($_REQUEST['type'] =='delivery')){
            $user_id = $data;
            $qrCodeData =  $user_id; // Customize the data to be encoded in the QR code as per your requirements
            $name = uniqid() . '.png';
            $qrCodePath =  $_SERVER['DOCUMENT_ROOT'].'/' . $Config['uploads_path'] . 'qr_codes/' . $name; // Path where the QR code image will be saved
            QRcode::png($qrCodeData, $qrCodePath, QR_ECLEVEL_L, 10);
        // echo $qrCodePath; die();
            $userAdmObj->addQRCode($user_id, $name);
        }
        
        
    if($user_id && $data){
        
    // $Data = $data?$data:""; 
    // print_r($userDetailsData);die();
    
    // if ($temp['qr_code'] != '' && $temp['qr_code'] != null) {
    //             // Delete old image from the server
               
    //             $old_img = $_SERVER['DOCUMENT_ROOT'].'/' . $Config['uploads_path'] . 'users/' . $userDetailsData['img'];
    //         //   echo $old_img;
    //         //   die();
    //             if (file_exists($old_img)) {
    //                 @unlink($old_img);
    //             }
                
    //         }
        if ($temp['img'] != '' && $temp['img'] != null) {
                // Delete old image from the server
               
                $old_img = $_SERVER['DOCUMENT_ROOT'].'/' . $Config['uploads_path'] . 'users/' . $userDetailsData['img'];
            //   echo $old_img;
            //   die();
                if (file_exists($old_img)) {
                    @unlink($old_img);
                }
                
            }
                //   echo $temp['card_img']; die();
                if ($temp['card_img'] != '' && $temp['card_img'] != null) {
                    // Delete old image from the server
                   
                    
                    $old_img = $_SERVER['DOCUMENT_ROOT'].'/' . $Config['uploads_path'] . 'users/' . $userDetailsData['card_img'];
                   if (file_exists($old_img)) {
                        @unlink($old_img);
                    }
                
            }
            if ($temp['licence'] != '' && $temp['licence'] != null) {
                // Delete old image from the server
               
                
                $old_img = $_SERVER['DOCUMENT_ROOT'].'/' . $Config['uploads_path'] . 'users/' . $userDetailsData['licence'];
                if (file_exists($old_img)) {
                    @unlink($old_img);
                }
               
            }
            if ($temp['car_licence'] != '' && $temp['car_licence'] != null) {
                // Delete old image from the server
               
                
                $old_img = $_SERVER['DOCUMENT_ROOT'].'/' . $Config['uploads_path'] . 'users/' . $userDetailsData['car_licence'];
                if (file_exists($old_img)) {
                    @unlink($old_img);
                }
               
            }
    }
    
    $Data = $data?$data:""; 
} 



if ($_GET['action'] == 'getUserScanInfo') {
    if ($_SERVER['REQUEST_METHOD'] === 'GET') {
        // Default language code to 'ar' if not provided
        $lang_code = isset($_GET['lang_code']) ? $_GET['lang_code'] : "ar";
        // Retrieve the user_id and entity_id from the request parameters
        $user_id = $Req['user_id'];
        $entity_id = $Req['entity_id'];
        
        // print_r($lang_code);
        // die();

        
        // Call the function to get user scan info
        try {

    // echo"test";
    // die();
            $userData = $userAdmObj ->getUserScanInfo($user_id, $entity_id, $lang_code);
            if (!empty($userData)) {
                $user = $userData[0]; // Get the first element of the $userData array

                if (isset($user['end_date'])) {
                    $end_date = $user['end_date'];
                    $current_date = date('Y-m-d');
   
                    if ($end_date > $current_date) {
                        $Data = array(
                            "User_data" => $userData,
                        );
                    } else {
                        $Data = array(
                            'errors' => 'Please renew your subscription to see your private information',
                        );
                    }
                }
            } else {
                $Data = array(
                    'errors' => 'No user data found',
                );
            }

            
        } catch (Exception $e) {
            // Handle and log any exceptions
            $errorData = array(
                'errors' => $e->getMessage(),
            );
            echo json_encode($errorData);
        }
    } else {
        // Invalid request method
        echo json_encode(['errors' => 'Invalid request method']);
    }
}


if ($_GET['action'] == 'deleteUser') {
    $Req = json_decode($postdata, true);
    // print_r($Req);
    // die();
            $userData = $userAdmObj->deleteUser($Req['id']);
            $Data     = $userData ? $userData : '';
        }
if ($_GET['action'] == 'getUserLevel') {
        
            $userLevelData = $userAdmObj->getUserLevel($Req);
// print_r($userLevelData);die();
            $Data = $userLevelData?$userLevelData:'';
            
     

    }
if ($_GET['action'] == 'getSearchUsersByType') {

        
        $user_type = $_GET['user_type'] ? $_GET['user_type'] : 'parent';
        $oneUsersData = $userAdmObj->getSearchUsersByType($user_type);
        $Data = $oneUsersData?$oneUsersData:'';
       
 

}    
if ($_GET['action'] == 'getUsersCountByType') { 
    if ($_SERVER['REQUEST_METHOD'] === 'GET') {
        $userType = $_GET['user_type'];
        // echo $userType;
        $usersData = $userAdmObj->getUsersCountByType($userType);
        $Data = $usersData?$usersData:''; 
    }
  
}    




echo json_encode($Data);

    
// }
// else{
//         echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
//     }