<?php

$levelsObj = new levels(); 

class levels {

var $mDb; 
var $mConfig; 

function __construct() {
	global $Config; 
	$this -> mDb = new iplus(); 
	$this -> mConfig = $Config; 
}


function getSomeLevels($aStart, $aLimit, $sort, $type, $searchName) {
	$sql = "SELECT l.id, l.level_name, l.date_added, u.full_name AS 'user_full_name' FROM `user_levels` l";
	$sql .= " LEFT JOIN `users` u ON u.id = l.user_id ";
	$sql.= " WHERE l.id > 0";
    $sql.= $searchName ? ' AND l.level_name like "%'.$searchName.'%"' : '';
//	$sql.=  $level_name ? " AND l.level_name ='{$level_name}' " : '';
	$sql .= " ORDER BY l.{$sort} {$type}";
	$sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

//	 echo $sql; die();

	return $this -> mDb -> getAll($sql); 
}

function getSearchLevelsCount($sort, $type, $searchName,$level_name) {
	$sql = "SELECT COUNT(`id`) as 'result_count' FROM `user_levels`";
	$sql.= " WHERE `id` > 0";
    $sql.= $searchName ? ' AND `level_name` like "%'.$searchName.'%"' : '';
//	$sql.= $level_name &&  $level_name !=''&&  $level_name !=null? " AND `level_name` ='{$level_name}' " : '';

	$sql .= " ORDER BY {$sort} {$type}";

//	echo $sql; die();

	return $this -> mDb -> getOne($sql); 
}

function getLevelsCount(    ) {
	$sql = "SELECT COUNT(`id`) as 'count' FROM `user_levels` ";
//    echo  $sql;
//    die();
	return $this -> mDb -> getOne($sql); 
}

function addEditLevel($temp) {

	// print_r($temp); die();

	if ($temp['id'] === null || $temp['id'] === '') {
		// add
		unset($temp['id']);

		$dateTime = date('Y-m-d H:i:s');

		$sql = "INSERT INTO `user_levels` SET "; 
		foreach ($temp as $k => $v) {
		    if($v ==''){
                $v='0';
            }
			$sql .= "`{$k}`='{$v}',"; 
		}
		$sql .= " `date_added` = '{$dateTime}'";
// echo $sql;die();
		$res = $this -> mDb -> query($sql); 
		return $res;

	}
	else{
		// edit
		$sql = "UPDATE `user_levels` SET "; 
		foreach ($temp as $k => $v) {
            if($v ==''){
                $v='0';
            }
			$sql .= "`{$k}`='{$v}',"; 
		}
		$sql = substr($sql, 0, -1);
		$sql .= " WHERE `id` = '{$temp['id']}'"; 
//     echo $sql;die();

		$res = $this -> mDb -> query($sql); 
		return $res; 

	}

}

function getOneLevel($id) {
    // SQL query construction
    $sql = "SELECT * FROM `user_levels` WHERE `id` = :id";


    try {
        // Prepare the SQL statement
        $stmt = $this->mDb->connect()->prepare($sql);

        // Bind parameters
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);

        // Execute the statement
        $stmt->execute();

        // Fetch the row
        $result = $stmt->fetch(PDO::FETCH_ASSOC);
        // print_r($result);
        // die();

        return $result; // Return the fetched row or false if no row found
    } catch (PDOException $e) {
        // Handle database errors
        error_log("PDOException: " . $e->getMessage());
        return false; // Return false or handle error as needed
    }
}


function deleteLevel($ids) {
    
     $levels_id = '(' . implode(',', $ids) . ')';
     
	$sql = "DELETE FROM `user_levels` ";
	$sql.= " WHERE `id` IN $levels_id";


  $stmt = $this->mDb->connect()->prepare($sql);
    
 
        if ($stmt->execute()) {
    return true;
} else {
    return false;
}














}


}?>