<?php

/* * *************************************************************************
 *
 *   PROJECT: BigWish App
 *   powerd by IT PLUS Team
 *   Copyright 2020 IT Plus Inc
 *   http://it-plus.co/ *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */

header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: GET,POST,PUT,DELETE,OPTIONS');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');


require_once 'init.php';

// Start Functionality
$postdata = file_get_contents("php://input");

// $token  = apache_request_headers()["Authorization"];
// $verify = $hs256Obj->verifyJWT('sha256', $token);

// print_r (apache_request_headers());
// die();

if($_GET['action'] == 'getAllEntities') {
    
    if ($_SERVER['REQUEST_METHOD'] === 'GET') {
        
        $lang_code = $_GET['lang_code'] ? $_GET['lang_code'] : "ar";
        $start         = $_GET['start'] ? $_GET['start'] : 0;
        $aItemsPerPage = $_GET['aItemsPerPage'] ? $_GET['aItemsPerPage'] : 5;

        $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
        $type = $_GET['type'] ? $_GET['type'] : 'DESC';

        $searchName = $_GET['searchName'] ? $_GET['searchName'] : '';
        
        $entityCount = $entityObj->getEntitiesCount($searchName,$lang_code,$type);
        
        

        $entity_data = $entityObj->getAllEntities($start, $aItemsPerPage, $lang_code, $searchName , $type);
        // $Data = $entity_data ? $entity_data : '';
        
         $Data = array(
            "Entity_count" => $entityCount,
            "Entity_data" => $entity_data
        );
        // print_r($Data);
        // die();
        // // echo"test";
       
    }
}  


if ($_GET['action'] == 'addEditEntity') {
//   print_r($_GET['img']);die();
    $operation = $_REQUEST['operation'];
    $entity_id = '';

    $temp = array();

    $allow_ext = array("jpg", "gif", "png", "jpeg", "bmp", "webp");
    $maxsize = 1024 * 20; //kb
    // $uploadFolder = 'wethaq/api/uploads/banks';
    $uploadFolder = $Config['uploads_path'] . 'entities';

    $thumbsConfig = array(
        array(
            'name' => 'medium',
            'width' => '240',
            'hight' => '250'
        ),
        array(
            'name' => 'small',
            'width' => '80',
            'hight' => '80'
        ),
    );
    
    $upload = new Upload($allow_ext, $thumbsConfig, $maxsize, $uploadFolder, false);
    // print_r($_FILES);die();
    foreach($_FILES as $key => $img){
        if (isset($_FILES[$key]['name']) AND $_FILES[$key]['name'] != '') {
        
            //get file name
            $file['name'] = addslashes($_FILES[$key]["name"]);
            // get file type
            $file['type'] = $_FILES[$key]['type'];
            // get filesize in KB
            $file['size'] = $_FILES[$key]['size'] / 1024;
            // get file tmp path
            $file['tmp'] = $_FILES[$key]['tmp_name'];
            //get file ext [to get max uploades size]
            $file['ext'] = $upload->GetExt($_FILES[$key]["name"]);
            //check if guest have selected file or not
            if ($file['name'] != '') {
                // Start Uploading File
                $upfile = $upload->Upload_File($file, $maxsize);
                //if uploagetCategoryByParentIDding successfully
                // echo $upfile;die();
                if ($upfile) {
                    $temp[$key] = $upfile['newname'];
                    // print_r ($temp[$key]);die();
                } else {
                    $error = true;
                    $showError[] = $upload->showErrors();
                    $top_msg['error'][] = $showError[0][0];
                     echo $showError[0][0];die();
                }
            }
        }
        else
        {
            $temp = null;
        }
       
    }

    $entity_id = $_REQUEST['id'];
    // return$_REQUEST['id'];

    // print_r($_REQUEST);die();
    $data = $entityObj->addEditEntity($_REQUEST, $temp["img"], $entity_id );
    $Data = $data?$data:""; 
} 




if ($_GET['action'] == 'deleteEntity') {
    $Req = json_decode($postdata, true);
    // print_r($Req);
    // die();
            $entityData = $entityObj->deleteEntity($Req['id']);
            $Data     = $entityData ? $entityData : '';
        }




echo json_encode($Data);
