<?php
// echo "test";
// die();
$planSubscriptionObj = new planSubscription();

class planSubscription {

    var $mDb; 
    var $mConfig; 
    var $mMailer;

    function __construct() {
        global $Config; 
        $this->mDb = new iplus(); 
        $this->mConfig = $Config; 
        $this->mMailer = new Mailer();

    }
function convert_object_to_array($data) {
        if (is_object($data)) {
            $data = get_object_vars($data);
        }
        
        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        }
        else {
            // echo "test"; die();
            return $data;
        }
    }
    
    
function getAllplanSubscription($start,$perpage,$lang_code, $searchName, $type, $sort) {
        
         $result=array();
        
        $sql = "SELECT p.*, pl.name, pl.description ,pl.lang_code, u.full_name as added_by FROM subscription_plan p LEFT JOIN subscription_plan_langs pl ON pl.subscription_plan_id = p.id and pl.`lang_code`=:lang_code LEFT JOIN users u ON p.added_by = u.id WHERE p.id > 0 ";

        
        if ($searchName) {
        $sql .= " AND el.name LIKE :searchName"; 
    }
    
        // if ($type) {
        //     $sql .= " AND e.type LIKE :type"; 
        // }
    
        // Remove single quotes around limit placeholders
            $sql .= " LIMIT " . (int)$start . ", " . (int)$perpage;
    // echo $sql; die();
        
            $stmt = $this->mDb->connect()->prepare($sql);

     if (!$stmt) {
            
            throw new Exception("Error preparing the SQL statement."); 
        }

        $stmt->bindParam(':lang_code', $lang_code, PDO::PARAM_STR);
        if ($searchName) {
            $searchName = '%' . $searchName . '%';
            $stmt->bindParam(':searchName', $searchName, PDO::PARAM_STR);
        }
        // if ($type) {
        //     $type = '%' . $type . '%';
        //     $stmt->bindParam(':type', $type, PDO::PARAM_STR); 
        // }

        // Make sure the limit parameters are bound as integers

        // $stmt->bindParam(':start', $start, PDO::PARAM_STR); 
        // $stmt->bindParam(':perpage', $perpage, PDO::PARAM_STR);
        
        if (!$stmt->execute()) { 
             
            throw new Exception("Error executing the SQL statement: " . implode(", ", $stmt->errorInfo()));
        }
        $result = $stmt->fetchAll(PDO::FETCH_ASSOC); // Fetch all results
   

    return $result;
}
 
    function getplanSubscriptionCount($searchName,$lang_code) {
	$sql = "SELECT COUNT(p.`id`) as 'count' FROM `subscription_plan` p ";
    $sql .= " LEFT JOIN `subscription_plan_langs` pl ON p.`id` = pl.`subscription_plan_id` ";
    $sql .= " WHERE p.`id` > 0 AND pl.`lang_code`  ='{$lang_code}' ";
    $sql .= $searchName ? ' AND pl.`name` like "%' . $searchName . '%"' : '';
    // $sql .= $partnerType ? ' AND a.`type` like "%' . $partnerType . '%"' : '';
    // $sql .= " AND c.`type` = '" . $partnerType . "'";
	return $this -> mDb -> getOne($sql); 
}
    

    

}
